<?php
namespace OrganizationsManagement\Controller;
use Exception;
use OrganizationsManagement\Traits\TQuery;
use OrganizationsManagement\Traits\TResponse;
use OrganizationsManagement\Util\Utilities;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;
use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Service\Classification as ClassificationService;

class Classification extends Simple {

    use TResponse;

    /**
     * @var ClassificationService
     */
    private $classificationService;

    /**
     * Classification constructor.
     * @param ClassificationService $classificationService
     */
    public function __construct(ClassificationService $classificationService)
    {
        $this->classificationService = $classificationService;
    }

    /**
     * @param DTO\Request $request
     * @param DTO\Response $response
     * @throws Exception
     */
    public function findClassification(DTO\Request $request, DTO\Response $response){
        try{
            $onlySubject = $request->getParameter('ONLY_SUBJECT') ?? null;
            $data = $this->classificationService->findClassification($onlySubject);
            $this->sendResponse($data, 200);
        }catch(Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}
