<?php
namespace OrganizationsManagement\Util;

use Zeedhi\Framework\DependencyInjection\InstanceManager;
use OrganizationsManagement\Util\Instance\Service as InstanceService;
use OrganizationsManagement\Util\Instance\Repository as InstanceRepository;
use OrganizationsManagement\Util\Instance\Factory as InstanceFactory;

class InstanceProvider {
    
    public static function getService()
    {
        return InstanceService::getInstance();
    }
    
    public static function getRepository()
    {
        return InstanceRepository::getInstance();
    }
    
    public static function getFactory()
    {
        return InstanceFactory::getInstance();
    }
    
    /** @return \OrganizationsManagement\Util\Utilities */
    public static function getUtilities()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Util\Utilities');
    }

    /** @return \OrganizationsManagement\Util\DBConnection */
    public static function getDBConnection()
    {
        return InstanceManager::getInstance()->getService('dbConnection');
    }
    
    /** @return \Doctrine\ORM\EntityManager */
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }
    
    /** @return \Teknisa\Libs\Controller\Api */
    public static function getLibsControllerApi()
    {
        return InstanceManager::getInstance()->getService('\Teknisa\Libs\Controller\Api');
    }

    /** @return \Teknisa\Libs\Util\Environment */
    public static function getLibEnvironment()
    {
        return InstanceManager::getInstance()->getService('libEnvironment');
    }
    
    public static function getNewCode(){
        return InstanceManager::getInstance()->getService('newCodeSC');
    }

    /** @return \Zeedhi\Framework\DB\Mongo\Mongo */
    public static function getLicenseMongoDB()
    {
        return InstanceManager::getInstance()->getService('licenseMongoDB');
    }

    /** @return \Zeedhi\Zmart\QueryBuilders\Mongo\QueryBuilder */
    public static function getMongoQueryBuilder()
    {
        return InstanceManager::getInstance()->getService('mongoQueryBuilder');
    }

    /** @return Teknisa\Libs\Util\ConnectionCustom */
    public static function getLibConnectionCustom()
    {
        return InstanceManager::getInstance()->getService('connectionCustom');
    }
}