/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8995_SUPTRGO.sql

Descrio:
Criao:
10/07/2009 Marcelo Alexsandro
*/

CREATE OR REPLACE TRIGGER EXCLUI_NF_ENT_OL
BEFORE DELETE
ON NOTAFISCAL FOR EACH ROW
DECLARE
V_REGISTRO          VARCHAR(1);
V_IDBAIXAAF         VARCHAR(1);
V_TOTALITEM         NUMBER;
V_BAIXATOTAL        NUMBER;
V_BAIXAMANUAL       NUMBER;
V_EMABERTO          NUMBER;
V_BAIXAPARCIAL      NUMBER;
V_REGISTRO_ANTERIOR VARCHAR2(18);
V_LISTA             VARCHAR2(20); /* NUMERO DA PRXLISTA SOBRE GRUPFILI */
BEGIN
   IF :OLD.DSNOTAFISORIGOL IS NOT NULL THEN
      NOVO_CODIGO_SC('LISTA', V_LISTA, 1);
      V_LISTA := SUBSTR(V_LISTA, 11, 10);
      V_REGISTRO_ANTERIOR := ' ';
      V_REGISTRO := 'N';
      FOR C_NF IN
         (SELECT
             SUBSTR(:OLD.DSNOTAFISORIGOL, 1, 4) CDFILIAL,
             SUBSTR(:OLD.DSNOTAFISORIGOL, 5, 10) NRLANCTONF,
             CDFILDEST,
             CDFILLANC,
             NRPEDEXOL,
             CDMARCA,
             CDPRODUTO,
             DTPROGENPEOL
          FROM NFRELACPEXOL
          WHERE CDFILIAL = SUBSTR(:OLD.DSNOTAFISORIGOL, 1, 4)
            AND NRLANCTONF = SUBSTR(:OLD.DSNOTAFISORIGOL, 5, 10)
          ORDER BY CDFILDEST, CDFILLANC, NRPEDEXOL
         )
      LOOP
         IF V_REGISTRO = 'N' THEN
            UPDATE NFRELACPEXOL
            SET IDENTRADAPEDOL = 'N'
            WHERE CDFILIAL = C_NF.CDFILIAL
              AND NRLANCTONF = C_NF.NRLANCTONF;
            V_REGISTRO := 'S';
         END IF;
         IF V_REGISTRO_ANTERIOR <> C_NF.CDFILDEST||C_NF.CDFILLANC||C_NF.NRPEDEXOL THEN
            INSERT INTO LISTA (NRLISTA, CDLISTA)
            SELECT
               V_LISTA,
               C_NF.CDFILDEST||C_NF.CDFILLANC||C_NF.NRPEDEXOL
            FROM DUAL
            WHERE NOT EXISTS (SELECT 1
                              FROM LISTA L
                              WHERE L.NRLISTA = V_LISTA
                                AND L.CDLISTA = C_NF.CDFILDEST||C_NF.CDFILLANC||C_NF.NRPEDEXOL);

            V_REGISTRO_ANTERIOR := C_NF.CDFILDEST||C_NF.CDFILLANC||C_NF.NRPEDEXOL;
         END IF;

         UPDATE ITEMPEDEXOL
         SET IDBAIXENPEOL = NULL
         WHERE CDFILDEST    = C_NF.CDFILDEST
           AND CDFILLANC    = C_NF.CDFILLANC
           AND NRPEDEXOL    = C_NF.NRPEDEXOL
           AND CDMARCA      = C_NF.CDMARCA
           AND CDPRODUTO    = C_NF.CDPRODUTO
           AND DTPROGENPEOL = C_NF.DTPROGENPEOL;
      END LOOP;

      FOR C_LISTA IN
         (SELECT
             SUBSTR(CDLISTA, 1, 4) CDFILDEST,
             SUBSTR(CDLISTA, 5, 4) CDFILLANC,
             SUBSTR(CDLISTA, 9, 10) NRPEDEXOL
          FROM LISTA
          WHERE NRLISTA = V_LISTA)
      LOOP
         V_TOTALITEM    := 0;
         V_BAIXATOTAL   := 0;
         V_BAIXAMANUAL  := 0;
         V_EMABERTO     := 0;
         V_BAIXAPARCIAL := 0;

         SELECT COUNT(*) INTO V_TOTALITEM -- BUSCA O TOTAL DE ITENS DA AF
         FROM ITEMPEDEXOL
         WHERE
            C_LISTA.CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
            C_LISTA.CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
            C_LISTA.NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL;

         SELECT COUNT(*) INTO V_EMABERTO  -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
         FROM ITEMPEDEXOL
         WHERE
            C_LISTA.CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
            C_LISTA.CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
            C_LISTA.NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
            ITEMPEDEXOL.IDBAIXENPEOL IS NULL;

         SELECT COUNT(*) INTO V_BAIXAPARCIAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
         FROM ITEMPEDEXOL
         WHERE
            C_LISTA.CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
            C_LISTA.CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
            C_LISTA.NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
            ITEMPEDEXOL.IDBAIXENPEOL = '1';

         SELECT COUNT(*) INTO V_BAIXATOTAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
         FROM ITEMPEDEXOL
         WHERE
            C_LISTA.CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
            C_LISTA.CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
            C_LISTA.NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
            ITEMPEDEXOL.IDBAIXENPEOL = '2';

         SELECT COUNT(*) INTO V_BAIXAMANUAL -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
         FROM ITEMPEDEXOL
         WHERE
            C_LISTA.CDFILDEST = ITEMPEDEXOL.CDFILDEST AND
            C_LISTA.CDFILLANC = ITEMPEDEXOL.CDFILLANC AND
            C_LISTA.NRPEDEXOL = ITEMPEDEXOL.NRPEDEXOL AND
            ITEMPEDEXOL.IDBAIXENPEOL = '3';

         IF V_TOTALITEM = V_EMABERTO THEN
            V_IDBAIXAAF := NULL;  -- AF EM ABERTO
         END IF;
         IF V_TOTALITEM = V_BAIXATOTAL THEN
            V_IDBAIXAAF := '2';   -- AF COM BAIXA TOTAL
         END IF;
         IF V_BAIXAPARCIAL > 0 THEN
            V_IDBAIXAAF := '1';   -- AF COM BAIXA PARCIAL
         END IF;
         IF (V_TOTALITEM = V_BAIXATOTAL + V_BAIXAMANUAL) AND
            (V_BAIXAMANUAL > 0) THEN
            V_IDBAIXAAF := '3';   -- AF COM BAIXA MANUAL
         END IF;
         IF (V_TOTALITEM = V_BAIXATOTAL + V_BAIXAMANUAL + V_EMABERTO) AND
            (V_EMABERTO > 0) AND (V_EMABERTO < V_TOTALITEM) THEN
            V_IDBAIXAAF := '1';   -- AF COM BAIXA PARCIAL
         END IF;

         UPDATE PEDIDOEXOL  -- ALTERA O ID DE BAIXA DA AF
         SET IDBAIXEXOL = V_IDBAIXAAF
         WHERE
            C_LISTA.CDFILDEST = PEDIDOEXOL.CDFILDEST AND
            C_LISTA.CDFILLANC = PEDIDOEXOL.CDFILLANC AND
            C_LISTA.NRPEDEXOL = PEDIDOEXOL.NRPEDEXOL;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXCLUI_NF_ENT_OL','5.05.066'); END;
/

